<template>
    <div class="referral-v2-redeem relative z-50">
        <div v-loading="isGettingPageData" class="p-4" v-if="isGettingPageData"></div>
        <template v-else>
            <div class="referral-v2-redeem__info">
                <div class="left">
                    <div class="referral-v2-redeem__info-stats">
                        <span class="title">{{ $t("referral_count") }}:</span>
                        <span class="count">{{ pageData.referralData.ReferralCount }}</span>
                    </div>
                    <div class="referral-v2-redeem__info-stats">
                        <span class="title">{{ $t("effective_referral_count") }}:</span>
                        <span class="count">{{ pageData.referralData.EffectiveReferralCount }}</span>
                    </div>
                </div>
                <div class="right">
                    <div class="referral-v2-redeem__info-stats">
                        <span class="title">{{ $t("redeemable") }}:</span>
                        <span class="count redeem">{{ pageData.referralData.FormattedRedeemable }}</span>
                    </div>
                    <div class="referral-v2-redeem__info-action">
                        <el-button @click="applyRedeem" round class="redeem-btn action-button-primary"
                            :disabled="isGettingPageData || isSubmitingRedeem || pageData.referralData.Redeemable <= 0">
                            <span>{{ $t('redeem') }}</span>
                        </el-button>
                    </div>
                </div>
            </div>
            <div class="referral-v2-redeem-table">
                <el-table :data="pageData.referralData.ReferralMemberList" border style="width: 100%;">
                    <el-table-column width="auto">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text">{{ $t('member') }}</p>
                                <p class="header-text hide-on-desktop mt-1">{{ $t('register_time') }}</p>
                            </div>
                        </template>
                        <template #default="scope: { row: ReferralMember }">
                            <div class="text-center body-cell">
                                <p class="body-cell__text">{{ scope.row.Username }}</p>
                                <p class="body-cell__text hide-on-desktop mt-1">{{ scope.row.FormattedRegisteredTime }}</p>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column width="auto" v-if=" sizes.width >= 1024 ">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text">{{ $t('register_time') }}</p>
                            </div>
                        </template>
                        <template #default=" scope: { row: ReferralMember } ">
                            <div class="text-center body-cell">
                                <p class="body-cell__text" :key=" scope.row.FormattedRegisteredTime ">{{
                                    scope.row.FormattedRegisteredTime }}</p>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column width="auto" v-if=" sizes.width >= 1024 ">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text">{{ $t('currency') }}</p>
                            </div>
                        </template>
                        <template #default=" scope: { row: ReferralMember } ">
                            <div class="text-center body-cell">
                                <p class="body-cell__text" :key=" scope.row.Currency ">{{ scope.row.Currency }}</p>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column width="auto" min-width="100px">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text hide-on-desktop mb-1">{{ $t('currency') }}</p>
                                <p class="header-text">
                                    <span>{{ $t('Currently / By Deposit') }}</span>
                                </p>
                            </div>
                        </template>
                        <template #default=" scope: { row: ReferralMember } ">
                            <div class="text-center body-cell">
                                <p class="body-cell__text hide-on-desktop mb-1">{{ scope.row.Currency }}</p>
                                <p class="body-cell__text">
                                    <span>{{ scope.row.FormattedTotalDeposit }}</span> / <span>{{ scope.row.FormattedQualifiedDepositLimit }}</span>
                                </p>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column width="auto" min-width="100px">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text hide-on-desktop mb-1">{{ $t('currency') }}</p>
                                <p class="header-text">
                                    <span>{{ $t('Currently / By Turnover') }}</span>
                                </p>
                            </div>
                        </template>
                        <template #default=" scope: { row: ReferralMember } ">
                            <div class="text-center body-cell">
                                <p class="body-cell__text hide-on-desktop mb-1">{{ scope.row.Currency }}</p>
                                <p class="body-cell__text" >
                                    <span>{{ scope.row.FormattedTotalTurnover }}</span> / <span>{{ scope.row.FormattedQualifiedTurnoverLimit
                                        }}</span>
                                </p>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column width="auto">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text">{{ $t('bonus_amount') }}</p>
                            </div>
                        </template>
                        <template #default=" scope: { row: ReferralMember } ">
                            <div class="text-center body-cell">
                                <p class="body-cell__text">{{ scope.row.FormattedBonusAmount }}</p>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column width="auto">
                        <template #header>
                            <div class="text-center p-2">
                                <p class="header-text">{{ $t('remark') }}</p>
                            </div>
                        </template>
                        <template #default=" scope: { row: ReferralMember } ">
                            <div class="text-center body-cell">
                                <p class="body-cell__text" :class="scope.row.FormattedInValidReason.toLowerCase() === 'effective' ? 'success' : 'error'" style="text-transform: none;" >{{ $t(scope.row.FormattedInValidReason) }}</p>
                            </div>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
        </template>
    </div>
</template>

<script setup lang="ts">
import { useReferralV2Redeem } from "~~/composables/referralv2/useReferralV2";
import { ReferralMember } from "~~/models/referral/referralV2";
const { sizes } = useResponsiveDimensions();

const {
    pageData,
    getPlayerRedeemRequest,
    applyRedeem,
} = useReferralV2Redeem();

onMounted(() => {
    getPlayerRedeemRequest();
})

</script>

<style scoped>
.referral-v2-redeem .referral-v2-redeem-table :deep(.el-table__empty-block) {
    border: none;
}
.referral-v2-redeem :deep(.el-table .el-table__header-wrapper .cell),
.referral-v2-redeem :deep(.el-table .el-table__header-wrapper .el-table__cell) {
    padding: 0;
}

.referral-v2-redeem :deep(.el-table .el-table__body-wrapper .cell),
.referral-v2-redeem :deep(.el-table .el-table__body-wrapper .el-table__cell) {
    padding: 0;
}

.referral-v2-redeem-table .body-cell {
    display: flex;
    flex-direction: column;
    gap: 4px;
    padding: 8px;
}

.referral-v2-redeem-table .body-cell .body-cell__text {
    color: var(--text5);
    text-align: center;
    font-size: 12px;
    font-style: normal;
    font-weight: 400;
    line-height: normal;
    text-transform: capitalize;
}

.referral-v2-redeem-table .body-cell .body-cell__text.error {
    color: var(--failure, #FF265C);
}

.referral-v2-redeem-table .body-cell .body-cell__text.success {
    color: var(--success,  #00FF00);
}
.referral-v2-redeem :deep(.el-table .el-table__header-wrapper .cell .header-text) {
    color: var(--text5);
    text-align: center;
    font-size: 12px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
    text-transform: capitalize;
}

/* table body scroll */
.referral-v2-redeem :deep(.el-table .el-table__body-wrapper .el-scrollbar__wrap) {
    --table-header-height: 64px;
    height: calc(var(--table-height) - var(--table-header-height));
}

@media only screen and (min-width: 424px) {
    .referral-v2-redeem :deep(.el-table .el-table__body-wrapper .el-scrollbar__wrap) {
    --table-header-height: 50px;
    }
}

@media only screen and (min-width: 1024px) {
    .referral-v2-redeem :deep(.el-table .el-table__body-wrapper .el-scrollbar__wrap) {
    --table-header-height: 31px;
    }
}
/* table body scroll end */

.referral-v2-redeem-table {
    margin-top: 1rem;
    border: 2px solid var(--border);
    border-radius: 8px;
}

.referral-v2-redeem :deep(div.el-table) {
    --el-table-border: 2px solid var(--border);
    --el-table-bg-color: transparent;
    --el-table-tr-bg-color: transparent;
    --table-height: 58vh;
    height: var(--table-height);
}

.referral-v2-redeem :deep(div.el-table) table .el-table__cell:first-child {
    border-left: unset;
}

.referral-v2-redeem :deep(div.el-table) table .el-table__cell:last-child {
    border-right: unset;
}

.referral-v2-redeem :deep(div.el-table) table th:first-child {
    border-left: unset;
}

.referral-v2-redeem :deep(div.el-table) table th:last-child {
    border-right: unset;
}

.referral-v2-redeem :deep(div.el-table) tr:last-child td:first-child {
    border-bottom-left-radius: 0;
}

.referral-v2-redeem :deep(div.el-table) tr:last-child td:last-child {
    border-bottom-right-radius: 0;
}

.referral-v2-redeem__info .redeem-btn {
    width: 100%;
    max-width: 160px;
    margin: 0 auto;
}

.referral-v2-redeem__info,
.referral-v2-redeem__info .left,
.referral-v2-redeem__info .right {
    display: flex;
    flex-direction: column;
    gap: 8px;
}

.referral-v2-redeem__info {
    padding-bottom: 1rem;
}

.referral-v2-redeem__info-stats {
    display: flex;
    justify-content: space-between;
    align-items: center;
    height: 40px;
}

.referral-v2-redeem__info-stats .title {
    color: var(--text5);
    font-size: 14px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
}

.referral-v2-redeem__info-stats .count {
    color: var(--text);
    font-size: 14px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
}

.referral-v2-redeem__info-stats .count.redeem {
    color: var(--text5);
    font-size: 20px;
    font-weight: 700;
}

.referral-v2-redeem__info-action {
    display: flex;
    justify-content: center;
}

@media only screen and (min-width: 1024px) {
    .referral-v2-redeem__info {
        justify-content: space-between;
    }

    .referral-v2-redeem__info,
    .referral-v2-redeem__info .left,
    .referral-v2-redeem__info .right {
        flex-direction: row;
        align-items: center;
    }

    .referral-v2-redeem__info .left {
        gap: 24px;
    }

    .referral-v2-redeem__info-stats {
        gap: 8px;
    }

    .referral-v2-redeem-table .hide-on-desktop {
        display: none;
    }

    .referral-v2-redeem-table {
        margin-top: 0;
    }
    
    .referral-v2-redeem :deep(div.el-table) {
        --table-height: 60vh;
    }
}
</style>